package org.example;

import java.util.LinkedList;
import java.util.Queue;

public class MyBlockingQueue<E> {
    private Queue<E> queue;
    private int maxNoOfTasks;
    public MyBlockingQueue(int maxNoOfTasks) {
        queue = new LinkedList<>();
        this.maxNoOfTasks = maxNoOfTasks;
    }
    public synchronized void put(E e) throws InterruptedException {
        while ( getQueueSize() == maxNoOfTasks) {
            wait();
        }
        queue.add(e);
        notifyAll();
    }
    public void setQueue(Queue<E> queue) {
        this.queue = queue;
    }
    public void setMaxNoOfTasks(int maxNoOfTasks) {
        this.maxNoOfTasks = maxNoOfTasks;
    }
    public Queue<E> getQueue() {
        return queue;
    }
    public int getMaxNoOfTasks() {
        return maxNoOfTasks;
    }
    public synchronized int getQueueSize() {
        return queue.size();
    }
    public synchronized E take() throws InterruptedException {
        while ( getQueueSize() == 0) {
            wait();
        }
        E item = queue.remove();
        notifyAll();
        return item;
    }
}